## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_with bootstrap

Name:           hypershell
Version:        2.7.0
Release:        %{autorelease}
Summary:        Utility for processing shell commands over a distributed, asynchronous queue

License:        Apache-2.0
URL:            https://hypershell.org
Source:         https://github.com/hypershell/hypershell/archive/%{version}/hypershell-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel

# for tests
BuildRequires:  python3-pytest
BuildRequires:  python3-yaml
BuildRequires:  sqlite
# for documentation
%if %{without bootstrap}
BuildRequires:  texinfo
BuildRequires:  python3dist(furo)
BuildRequires:  python3dist(docutils)
BuildRequires:  python3dist(hypershell)
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3dist(sphinxext-opengraph)
BuildRequires:  python3dist(sphinx-copybutton)
BuildRequires:  python3dist(sphinx-inline-tabs)
BuildRequires:  python3dist(sphinx-sitemap)
%endif

%global _description %{expand:
Elegant, cross-platform, high-throughput computing utility
for processing shell commands over a distributed, asynchronous queue.
Highly scalable workflow automation tool for many-task scenarios.
}

%description %_description

%pyproject_extras_subpkg -n python3-hypershell postgres

%prep
%autosetup
# loosen sqlalchemy requirement a little for el10
sed -i 's/"sqlalchemy>=2.0.29"/"sqlalchemy>=2.0.26"/g' pyproject.toml
#  remove unpackaged sphinx dependency
sed -i '/sphinxcontrib.details.directive/d' docs/conf.py

%generate_buildrequires
%pyproject_buildrequires -x postgres


%build
%pyproject_wheel
%if %{without bootstrap}
pushd docs
sphinx-build . texinfo -b texinfo
pushd texinfo
# Replace bare email with markup
sed -i "s/<glentner@purdue.edu>/@email{glentner@@purdue.edu}/g" hypershell.texi
makeinfo --docbook hypershell.texi
popd
popd
%endif

%install
%pyproject_install
%pyproject_save_files hypershell

install -pDm 0644 share/man/man1/hsx.1 %{buildroot}%{_mandir}/man1/hsx.1
install -pDm 0644 share/man/man1/hyper-shell.1 \
  %{buildroot}%{_mandir}/man1/hyper-shell.1
%if %{without bootstrap}
install -pDm 0644 docs/texinfo/hypershell.xml \
  %{buildroot}%{_datadir}/help/en/hypershell/hypershell.xml
%endif

%check
%pytest


%files -f %{pyproject_files}
%doc README.*
%license LICENSE
%exclude %{_bindir}/hs
%{_bindir}/hsx
%{_bindir}/hyper-shell
%{_mandir}/man1/hsx.1*
%{_mandir}/man1/hyper-shell.1*
%if %{without bootstrap}
%dir  %{_datadir}/help/en
%lang(en) %{_datadir}/help/en/hypershell
%endif

%changelog
## START: Generated by rpmautospec
* Thu May 29 2025 John Doe <packager@example.com> - 2.7.0-1
- Uncommitted changes
## END: Generated by rpmautospec
